package com.nisum.offertransactionservice.converter;

import com.nisum.offertransactionservice.model.Item;
import com.nisum.offertransactionservice.model.OfferTransactionRequest;
import com.nisum.offertransactionservice.model.PERequest;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;

import java.util.ArrayList;
import java.util.List;

@RunWith(MockitoJUnitRunner.class)
public class OfferConverterTest {

    @InjectMocks
    private OfferConverter offerConverter = new OfferConverter();

    @Before
    public void setUp() throws Exception {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void offerConverterTest() {
        PERequest peRequest = offerConverter.apply(getOfferTransactionRequest());
        Assert.assertEquals(peRequest, getPEReq());
    }


    private PERequest getPEReq() {
        PERequest peRequest = new PERequest();
        peRequest.setHhId("123");
        List<Item> itemList = new ArrayList<>();
        Item item1 = new Item("Coke", "12", 13.05, "cmsCoupons");
        Item item2 = new Item("Thumpsup", "11", 14.05, "cmsCoupons");
        itemList.add(item1);
        itemList.add(item2);
        peRequest.setItemList(itemList);
        /*OfferLookup offerLookup1 = new OfferLookup("1","12","234","02","AND","BOGO");
        OfferLookup offerLookup2 = new OfferLookup("2","13","234","02","OR","BXGY");
        List<OfferLookup> offerLookups = new ArrayList<>();
        offerLookups.add(offerLookup1);
        offerLookups.add(offerLookup2);
        peRequest.setEligibleOffers(offerLookups);*/
        return peRequest;
    }

    private OfferTransactionRequest getOfferTransactionRequest() {
        OfferTransactionRequest offerTransactionRequest = new OfferTransactionRequest();
        offerTransactionRequest.setHhId("123");
        List<Item> itemList = new ArrayList<>();
        Item item1 = new Item("Coke", "12", 13.05, "cmsCoupons");
        Item item2 = new Item("Thumpsup", "11", 14.05, "cmsCoupons");
        itemList.add(item1);
        itemList.add(item2);
        offerTransactionRequest.setItemList(itemList);
        return offerTransactionRequest;
    }
}
